/* report debug data from com port */
ddName = 'COM1'; ofn = 'com1get.log'

/* set communication mode */
'MODE '||ddName||':115200,N,8,1,TO=OFF'

/* protect the file system from inadvertent access */
if stream(ddName,'command','query exists') \= '\DEV\' || ddName
then do
  say 'ERROR: The device driver' ddName 'does not exist!'
  /* wait */
  '@pause'
  exit
  end

/* acquire the device driver */
rc=stream(ddName,'command','open read')
if rc \= 'READY:'
then do
  say rc 'Device driver' ddName 'currently in use. Please try later.'
  /* wait */
  '@pause'
  exit
  end

/* report com1get.cmd started */
info=copies('-',79) /* separator */
rc=lineout(ofn,info) ; say info
info='<com1get.cmd> started on <'||date()||'> at <'||time()'>'
rc=lineout(ofn,info) ; say info

/* catch these here to close the com port */
signal on error; signal on failure; signal on halt;
signal on novalue; signal on syntax;

do forever
  /* get debug data */
  ttyInput=charin(ddName,,1)
  /* report debug data */
  rc=charout(ofn,ttyInput)
  rc=charout(,ttyInput)
  end

/* cleanup */
signal ProcessComplete
exit

/* report signal information */
error: failure: novalue: syntax:
parse source system invokation filename
info=condition('c')||' condition raised at line '||sigl||' of'||'0D0A'x
info=info||filename||'0D0A'x||'|'||sourceline(sigl)
rc=lineout(ofn,info) ; say info

halt: ProcessComplete:
/* release the device driver */
rc=stream(ddName,'command','close')

/* report com1get.cmd stopped */
info='<com1get.cmd> stopped on <'||date()||'> at <'||time()'>'
rc=lineout(ofn,info) ; say info
info=copies('-',79) /* separator */
rc=lineout(ofn,info) ; say info
exit
